#!/bin/env python
#
# observed_values.py
# ---
# The range of values observed in the dataset.
#
# authors: david (sander_project@sidiprojects.us, 0x87B60D653A14517D)
#          jane (jane.yakowitz@gmail.com)
#
"""
Gives the observed value ranges from the dataset ucop9_03_08.dta.

Useful when adding noise.
"""
import pickle
import numpy as np
import os
from numpy.random import random_sample


class GPA(object):
    """Hacky way to get a sequence of GPAs.

       Indexed elements are memoized, so the object is consistent when you ask
       for the same index multiple times. Example:
           >>> gpa = GPA()
           >>> gpa[13]
           2.628863666213315
           >>> gpa[91]
           1.246154948273825
           >>> gpa[13]
           2.628863666213315
    """
    def __init__(self):
        self.cached = {}

    def __getitem__(self, item):
        try:
            gpa = self.cached[item]
        except KeyError:
            gpa = 4 * random_sample()
            self.cached[item] = gpa
        return gpa


college = ['', 'Berkeley', 'Davis', 'Irvine', 'Riverside', 'San Diego',
                'Santa Barbara', 'Santa Cruz', 'UCLA']
year = ['1992-1994', '1995-1997', '1998-2000', '2001-2003', '2004-2006']
state = ['', 'CA', 'NOT CA']
race = ['URM', 'Other', 'White', 'Asian']
sati_verbal = ['550-599', '700-', '600-649', '650-699', '', '500-549',
               '450-499', '200-449']
sati_math = ['550-599', '650-699', '700-', '600-649', '', '450-499', '500-549',
             '200-449']
satii_writ = ['500-549', '200-449', '650-699', '', '700-', '600-649', '550-599',
              '450-499']
satii_3rd_score = ['', '450-499', '600-649', '500-549', '550-599', '700-',
                   '650-699', '200-449']
satii_3rd_subject = ['', 'BY', 'CH', 'SP', 'AH', 'PH', 'MB', 'LT', 'CL', 'EB',
                     'LR', 'JL', 'WH', 'FR', 'SL', 'IT', 'KL', 'MH', 'FL', 'GM',
                     'GL', 'UH', 'M2', 'EH']

# nb: last value range is likely a typo in the original data
raw_hsgpa = ['', '3.00-3.24', '3.75-', '0.00-2.99', '3.25-3.49', '3.50-2.74']

ucadj_hsgpa = ['', '3.50-3.99', '4.00-4.49', '0.00-3.49', '4.50-']
num_of_ap = [np.nan,   2.,   6.,   0.,  10.,   4.,   1.,  22.,  13.,   5.,
             8., 3.,  11.,   9.,  15.,   7.,  12.,  48.,  16.,  14.,  18.,
             20., 26., 17., 21.,  24.,  32.,  19.,  52.,  38.,  28.,  30.,
             23., 34.,  27.,  25., 36., 46.,  40.,  44.,  31.,  66.,  56.,
             60., 80.,  64.,  65.,  68.,  42., 90., 54.,  35.,  29.,  72.,
             50., 108.,  76.,  41.,  37.,  49.,  63.,  33., 58., 88.,  39.,
             62., 70.]
parent_educa_max = ['', '7', '8', '5', '1', '2', '3', '6']
parent_income = ['', '100,000 or Above', '20,000-29,999', '50,000-59,999',
                 '40,000-49,999', '60,000-69,999', '70,000-79,999', '10,000-19,999',
                 '30,000-39,999', '90,000-99,999', '0-9,999', '80,000-89,999']
ca_api_rank = [np.nan,  7.,  3., 10.,  5.,  8.,  1.,  6.,  9.,  4.,  2.]
nan_or_1 = [np.nan, 1.]
rollovers01 = nan_or_1
rollovers03 = nan_or_1
rollovers04 = nan_or_1
rollovers05 = nan_or_1
rollovers06 = nan_or_1
rollovers07 = nan_or_1
rollovers08 = nan_or_1
rollovers09 = nan_or_1
elc_path = ['', 'N', 'E']
app00 = [np.nan, 0, 1]
app01 = [np.nan, 0, 1]
app02 = [np.nan, 0, 1]
app03 = [np.nan, 0, 1]
app04 = [np.nan, 0, 1]
app05 = [np.nan, 0, 1]
app06 = [np.nan, 0, 1]
app07 = [np.nan, 0, 1]
app08 = [np.nan, 0, 1]
app09 = [np.nan, 0, 1]
adm00 = [np.nan, 0, 1]
adm01 = [np.nan, 0, 1]
adm02 = [np.nan, 0, 1]
adm03 = [np.nan, 0, 1]
adm04 = [np.nan, 0, 1]
adm05 = [np.nan, 0, 1]
adm06 = [np.nan, 0, 1]
adm07 = [np.nan, 0, 1]
adm08 = [np.nan, 0, 1]
adm09 = [np.nan, 0, 1]

app_cipcat_01 = list(range(930262))
app_cipcat_03 = list(range(930262))
app_cipcat_04 = list(range(930262))
app_cipcat_05 = list(range(930262))
app_cipcat_06 = list(range(930262))
app_cipcat_07 = list(range(930262))
app_cipcat_08 = list(range(930262))
app_cipcat_09 = list(range(930262))
gpa_cum = ['', '3.60-3.69', '3.80-3.89', '3.30-3.39', '3.20-3.29',
           '3.50-3.59', '3.00-3.09', '2.70-2.79', '3.90-4.00', '2.20-2.29',
           '2.60-2.69', '2.80-2.89', '2.50-2.59', '3.10-3.19', '3.40-3.49',
           '2.90-2.99', '3.70-3.79', '2.30-2.39', '1.80-1.89', '2.10-2.19',
           '2.40-2.49', '1.30-1.39', '1.40-1.49', '0.00-1.09', '1.70-1.79',
           '1.10-1.19', '1.20-1.29', '2.00-2.09', '1.60-1.69', '1.50-1.59',
           '1.90-1.99']
grad_cipcat = ['', 'Other', 'Social Sci', 'Science', 'Undeclared']
gpa_1y = ['', '3.30-3.39', '3.70-3.79', '2.40-2.49', '3.00-3.09',
          '2.20-2.29', '3.50-3.59', '3.10-3.19', '3.60-3.69', '3.90-4.00',
          '3.40-3.49', '2.30-2.39', '3.20-3.29', '2.80-2.89', '2.90-2.99',
          '2.00-2.09', '3.80-3.89', '1.90-1.99', '2.70-2.79', '2.10-2.19',
          '1.50-1.59', '2.50-2.59', '2.60-2.69', '1.30-1.39', '1.80-1.89',
          '1.40-1.49', '1.60-1.69', '1.70-1.79', '0.00-1.09', '1.10-1.19',
          '1.20-1.29']
enr_campus = [np.nan,  1.,  3.,  9.,  5.,  6.,  8.,  7.,  4.]
bachelor = ['', 'Y', 'N']
ttd_qtrs00 = [np.nan, 12., 10., 13.5, 10.5, 16.5, 16., 13., 15., 11.5, 14.5,
              14., 11.]



gpacum100 = [x/10. for x in range(0, 41)]
bachelor4 = [np.nan,  0.,  1.]
hsgpa = [np.nan, 3.11999989, 3.86999989, 2.5, 3.36999989, 3.61999989]
adjhsgpa = [np.nan, 3.74000001, 4.23999977, 3., 4.5]
satverbal = [574., 724., 624., 674., np.nan, 524., 474., 400.]
satmath = [574., 674., 724., 624., np.nan, 474., 524., 400.]
satwrit = [524., 400., 674., np.nan, 724., 624., 574., 474.]
satii3rdscore = [np.nan, 474., 624., 524., 574., 724., 674., 400.]
bachelor2 = [np.nan,  1.,  0.]
gradontime = [np.nan,  1.,  0.]
grad5years = [np.nan,  1.,  0.]
incomepct = [np.nan, 96.30000305, 34.59999847, 74.69999695, 64.30000305,
             82., 86.80000305, 19.39999962, 50.40000153, 91.90000153,
             6.0999999, 89.90000153]
educpct = [np.nan, 79., 93.69999695, 49.40000153, 2.29999995, 8.60000038,
           25.10000038, 65.90000153]
gpacum = [np.nan, 3.6500001, 3.8499999, 3.3499999, 3.25,
          3.54999995, 3.04999995, 2.75, 3.95000005, 2.25, 2.6500001, 2.8499999,
          2.54999995, 3.1500001, 3.45000005, 2.95000005, 3.75, 2.3499999,
          1.85000002, 2.1500001, 2.45000005, 1.35000002, 1.45000005,
          1.04999995, 1.75, 1.14999998, 1.25, 2.04999995, 1.64999998,
          1.54999995, 1.95000005]
gpa1y = [np.nan, 3.3499999, 3.75, 2.45000005, 3.04999995,
         2.25, 3.54999995, 3.1500001, 3.6500001, 3.95000005, 3.45000005,
         2.3499999, 3.25, 2.8499999, 2.95000005, 2.04999995, 3.8499999,
         1.95000005, 2.75, 2.1500001, 1.54999995, 2.54999995, 2.6500001,
         1.35000002, 1.85000002, 1.45000005, 1.64999998, 1.75, 1.04999995,
         1.14999998, 1.25]
bin = [0, 1]
berkeley = bin
davis = bin
ucla = bin
riverside = bin
sandiego = bin
santacruz = bin
santabarbara = bin
irvine = bin
urm = bin
white = bin
asian = bin
other = bin
othercip = bin
sciencecip = bin
socialscicip = bin
undeclaredcip = bin
enteredscience = bin
ses = [np.nan, 87.65000153, 64.15000153, 95., 84.19999695,
       76.84999847, 71.65000153, 93.69999695, 56.84999847, 87.84999847,
       74.69999695, 49.40000153, 90.25, 79. , 49.20000076, 64.69999695,
       18.45000076, 72.84999847, 92.80000305, 14., 29.85000038, 68.09999847,
       36. , 84.44999695, 91.80000305, 62.04999924, 56.54999924, 15.60000038,
       7.3499999, 65.69999695, 89.90000153, 49.90000153, 82.90000153,
       81.09999847, 73.94999695, 80.5 , 42., 44.70000076, 85.44999695, 29.5,
       96.30000305, 57.5, 60.70000076, 72.05000305, 4.19999981, 37.75, 38.5,
       50.25, 41.65000153, 36.45000076, 65.09999847, 19.39999962, 56.79999924,
       69.65000153, 76.34999847, 64.30000305, 58.15000153, 34.40000153,
       45.29999924, 82., 65.90000153, 25.10000038, 22.25, 70.30000305, 27.75 ,
       78.90000153, 34.59999847, 53.54999924, 77.90000153, 10.85000038,
       33.29999924, 42.54999924, 42.65000153, 2.29999995, 21.60000038,
       47.70000076,  8.60000038, 50.40000153, 6.0999999, 26.35000038,
       70.65000153, 55.95000076, 44.54999924, 52.45000076, 91.90000153,
       86.80000305, 49.29999924, 58.5, 42.15000153, 47.09999847, 46.09999847,
       49.25]
sesnormed = [np.nan,  92.09999847,  69.30000305,  98.59999847,
             88.59999847,  82.69999695,  77.30000305,  62.29999924,
             93.69999695,  81.34999847,  51.25,  95.30000305, 84.15000153,
             47.29999924,  70.44999695,  12.05000019, 80., 6.80000019,
             24.60000038,  74.44999695, 30.85000038, 90.19999695,  97.,
             67.90000153, 58.25, 2.95000005,  73.40000153,  87.05000305,
             86.44999695, 80.55000305,  85.5,  38.65000153, 44.84999847,
             91.05000305,  21.95000076, 100., 64., 66.40000153,  79.,
             0.85000002, 33.59999847, 35.79999924,  55.45000076,  31.45000076,
             72.09999847,  13., 59.65000153,  75.09999847, 28.64999962,  46.5,
             18.39999962,  15.94999981, 76.30000305,  20.04999924, 56.90000153,
               4.80000019, 41.5,  43.25, 57.65000153]

indexrank = [32.,  92.,  98.,  65.,  63.,  74.,  46.,  93., 100.,
             76.,  82., 57.,  99.,  61.,  87.,  70.,  22.,  24.,  18., 81.,
             49.,  59., 90.,  84.,  44.,  79.,  33.,  28.,  89., 85.,  80.,
             68.,  14., 17.,  77.,   1.,  42.,  np.nan,  25., 60.,  94.,  83.,
             45.,  53., 88.,  91.,  38.,  95.,  30., 13.,  29.,  75.,  78.,
             11.,  26., 97.,  47.,  52.,  51., 37.,  72.,  23.,  12.,  96.,
             69.,  55., 4.,   3.,  58., 67.,  27.,  39.,  35.,  73.,  48.,
             20.,  86., 2.,  41., 7.,  10.,  54.,   9.,  36.,  64.,  71.,  31.,
             50., 40., 19.,  16.,  66.,  43.,   6.,  34.,  62.,   8.,  15.,
             5., 56.,  21.]
indexdecile = [4., 10.,  7.,  8.,  5.,  9.,  6.,  3.,  2.,  1., np.nan]

vars2vals = locals()
